#include<iostream>
#include<string.h>
#include<vector>
#include<queue>
#define MAXN 400000
using namespace std;
vector <pair<int, int> > a[MAXN];
vector <int> tree[MAXN];
int level[MAXN],mint[MAXN],parent[MAXN];

int time1=0;
int in[MAXN],out[MAXN];
void dfs (int vr) {
    in[vr]=time1++;
    for (auto to : tree[vr]) {
        dfs(to);
    }
    out[vr]=time1++;
}
int main () {
    int n,m,i,x,y,t;
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m ;
    for (i=0; i<m; i++) {
        cin >> x >> y >> t ;
        x--; y--;
        a[x].push_back({y,t});
        a[y].push_back({x,t});
    }

    queue <int> bfs;
    int curr;
    level[0]=1; mint[0]=0; parent[0]=-1;
    bfs.push(0);
    for (;;) {
        if (bfs.empty()==1) break;
        curr=bfs.front();
        bfs.pop();
        for (auto [to, t] : a[curr]) {
            if (level[to]==0) {
                level[to]=level[curr]+1;
                mint[to]=mint[curr]+t;
                parent[to]=curr;
                bfs.push(to);
            }
            else if (level[to]==level[curr]+1) {
                if (mint[to]>mint[curr]+t) {
                    mint[to]=mint[curr]+t;
                    parent[to]=curr;
                }
            }
        }
    }
    cout << level[n-1]-2 << " " << mint[n-1] << "\n";

    int q;
    cin >> q ;
    if (q>0) {
        for (i=1; i<n; i++) {
            tree[parent[i]].push_back(i);
        }
        dfs(0);
    }
    for (i=0; i<q; i++) {
        cin >> x >> y ;
        x--; y--;
        if (x==y) {
            cout << "0 0\n";
            continue;
        }
        if ((in[x]<=in[y])&&(in[y]<=out[x])) {
            cout << level[y]-level[x]-1 << " " << mint[y]-mint[x] << "\n";
        }
        else {
            cout << "0\n";
        }
    }
    return 0;
}
