#include<iostream>
#include<string.h>
#include<vector>
#include<queue>
#define MAXN 400000
using namespace std;
vector <pair<int, int> > a[MAXN];
int level[MAXN],mint[MAXN];
int level_end[MAXN];
int main () {
    int n,m,i,x,y,t;
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m ;
    for (i=0; i<m; i++) {
        cin >> x >> y >> t ;
        x--; y--;
        a[x].push_back({y,t});
        a[y].push_back({x,t});
    }

    queue <int> bfs;
    int curr;
    level[0]=1; mint[0]=0;
    bfs.push(0);
    for (;;) {
        if (bfs.empty()==1) break;
        curr=bfs.front();
        bfs.pop();
        for (auto [to, t] : a[curr]) {
            if (level[to]==0) {
                level[to]=level[curr]+1;
                mint[to]=mint[curr]+t;
                bfs.push(to);
            }
            else if (level[to]==level[curr]+1) {
                if (mint[to]>mint[curr]+t) {
                    mint[to]=mint[curr]+t;
                }
            }
        }
    }
    cout << level[n-1]-2 << " " << mint[n-1] << "\n";

    level_end[n-1]=1;
    bfs.push(n-1);
    for (;;) {
        if (bfs.empty()==1) break;
        curr=bfs.front();
        bfs.pop();
        for (auto [to, t] : a[curr]) {
            if (level_end[to]==0) {
                level_end[to]=level_end[curr]+1;
                bfs.push(to);
            }
        }
    }

    int q;
    cin >> q ;
    for (i=0; i<q; i++) {
        cin >> x >> y ;
        x--; y--;
        if (x==y) {
            cout << "0 0\n";
            continue;
        }
        if (level[x]+(level_end[x]-1)==level[n-1]) {
            cout << level[y]-level[x]-1 << " " << mint[y]-mint[x] << "\n";
        }
        else {
            cout << "0\n";
        }
    }
    return 0;
}
