
/*
  Builders.cpp
*/

#include <cstdio>
using namespace std;
int n;
double prob[21][21];

char vec_solveo[1<<21];
double memo[1<<21];

double solve( int d, int s ) {
    if(d == n) return 1.0;
    if(vec_solveo[s]) return memo[s];
    vec_solveo[s] = 1;
    double &ret = memo[s];
    ret = 0.0;
    for(int i=0; i<n; ++i)
      if((s & (1<<i)) == 0){
         double tmp = prob[d][i] * solve(d + 1, s|(1<<i));
         if(tmp > ret) ret = tmp;
      }
   return ret;
}

int main() {
   scanf("%d", &n);
   for(int i=0; i<n; ++i)
      for(int j=0; j<n; ++j){
         int w;
         scanf("%d", &w);
         prob[i][j] = w / 100.0;
      }

   double ret = solve(0, 0);
   printf("%.6f\n", ret*100.0);
   return 0;
}
