#include<iostream>
#include<vector>
#include<queue>
#include<cstdio>
#include<algorithm>
using namespace std;
const int MAX_N=400005;
const int MAX_P=1000000000;
const int MAX_Q=500005;

int n,m;
vector<pair<int,int> >v[MAX_N];
int level[MAX_N];
int dist[MAX_N];
int q;

int final_ans[MAX_N][2];

struct P
{
    int node;
    int edge;
};
P parent[MAX_N];

struct Q
{
    int from;
    int to;
    int posi;
};
Q que[MAX_Q];
int pos;

int comp(Q x,Q y)
{
    if(x.to==y.to)
    {
        return x.from<y.from;
    }
    return x.to<y.to;
}

struct A
{
    int verts;
    int distance;
    bool ok;
};
A ans[MAX_N];


void Read()
{
    scanf("%d %d",&n,&m);
    int x,y,t;
    for(int i=1;i<=m;i++)
    {
        scanf("%d %d %d",&x,&y,&t);
        v[x].push_back(make_pair(y,t));
        v[y].push_back(make_pair(x,t));
    }
    for(int i=2;i<=n;i++)
    {
        dist[i]=MAX_P;
    }
}
void BFS()
{
    queue<int>q;
    level[1]=0;
    q.push(1);
    dist[1]=0;
    while(!q.empty())
    {
        int k=q.front();
        q.pop();
        for(int i=0;i<v[k].size();i++)
        {
            int vert=v[k][i].first;
            int price=v[k][i].second;
            if(vert==1)continue;
            if(level[vert]==0)
            {
                level[vert]=level[k]+1;
                dist[vert]=dist[k]+price;
                q.push(vert);
                parent[vert].node=k;
                parent[vert].edge=price;
            }
            else
            {
                if(level[k]+1==level[vert])
                {
                    if(dist[vert]>dist[k]+price)
                    {
                        dist[vert]=dist[k]+price;
                         parent[vert].node=k;
                        parent[vert].edge=price;
                    }
                }
            }
        }
    }
}
/*
int Path(int e,int me)
{

    if(f==0)
    {
            cur=cur+parent[e].edge;

        //O(1);
    /*for(int i=0;i<v[e].size();i++)
    {
        if(v[e][i].first==parent[e]){cur+=v[e][i].second;break;}
    }
    */
    /*
    }
    if(parent[e].node==me)
    {
        f=1;
        return 0;
    }
    if(parent[e].node==1)return 0;

    int ans=0;
    ans=ans+Path(parent[e].node,me)+1;
    return ans;
}
*/
void Path(int e,int v,int d)
{
    if(parent[e].node==0)return;
    ans[parent[e].node].verts=v;
    ans[parent[e].node].distance=d;
    ans[parent[e].node].ok=true;
    //cout<<parent[e].node<<endl;
    Path(parent[e].node,v+1,parent[parent[e].node].edge+d);
}
void Queries()
{
    scanf("%d",&q);
    int x,y;
    for(int i=1;i<=q;i++)
    {
        scanf("%d %d",&x,&y);
        if(ans[x].ok==false)
        {
            printf("%d\n",0);
        }
        else
        {
            printf("%d %d\n",ans[x].verts,ans[x].distance);
        }
    }
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    Read();
    BFS();
    cout<<level[n]-1<<" "<<dist[n]<<endl;
    for(int i=1;i<=n;i++)
    {
        ans[i].verts=0;
        ans[i].distance=0;
        ans[i].ok=false;
    }
    Path(n,0,parent[n].edge);
    //return 0;
    Queries();








    return 0;
}
/*
5 8
1 2 1
2 3 2
1 3 5
3 4 1
3 5 3
4 5 1
1 6 2
6 5 2


3
2 3
3 5
1 4


/////////
5 6
1 2 1
2 3 2
1 3 5
3 4 1
3 5 3
4 5 1
4
2 5
3 5
1 5
5 5

*/

