#include <iostream>
#include <queue>
#include <vector>
#include <limits.h>
using namespace std;
typedef long long ll;
const ll maxn = 2e5+10, maxm = 6e6+10, maxt = 1e4+10, inf = 1e15;

priority_queue < pair < ll, ll > > q[maxt];
pair < ll, ll > path[maxn];
vector < pair < ll, ll > > v[maxn];

void init_path() {
    q[0].push({0, 1});
    path[1] = {0, 0};
    for (ll d = 0 ; d < maxt ; ++d) {
        while (!q[d].empty()) {
            //auto [km, x] = q.top();
            ll km = q[d].top().first;
            ll x = q[d].top().second;
            q[d].pop();
            km = -km;
            if (path[x].second < km) continue;
            //cout << "top: " << x << ' ' << d << ' ' << km << '\n';
            for (auto p : v[x]) {
                ll y = p.first;
                ll ed = p.second;
                if (path[y].first == -1 || (path[y].first == d+1 && path[y].second > km+ed)) {
                    path[y] = {d+1, km+ed};
                    q[d+1].push({-km-ed, y});
                }
            } 
        }
    }  
}

ll n, m, x, y, d;

int main () {
    for (ll i = 0 ; i < maxn ; ++i)
        path[i] = {-1, inf};
    cin >> n >> m;
    for (ll i = 0 ; i < m ; ++i) {
        cin >> x >> y >> d;
        v[x].push_back({y, d});
        v[y].push_back({x, d});
    }
    init_path();
    cout << path[n].first-1 << ' ' << path[n].second << '\n';
    return 0;
}