#include <iostream>
#include <iomanip>
using namespace std;
const int maxn = 21, maxb = 1 << maxn;
double dp[maxn][maxb];
bool bl[maxn][maxb];

double a[maxn][maxn];
int n, x;

double f(int ix, int mask) {
    if (ix == n) return 1.0000000;
    if (bl[ix][mask]) return dp[ix][mask];
    bl[ix][mask] = 1;
    dp[ix][mask] = 0.0000000;
    for (int i = 0 ; i < n ; ++i) {
        if (!(mask & (1 << i))) {
            dp[ix][mask] = max(dp[ix][mask], a[ix][i] * f(ix+1, mask | (1 << i)));
        }
    }
    return dp[ix][mask];
}

int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    for (int i = 0 ; i < n ; ++i) {
        for (int j = 0 ; j < n ; ++j) {
            cin >> x;
            a[i][j] = (double)x / 100.0000000;
        }
    }
    cout << fixed << setprecision(6) << 100.0000000*f(0, 0) << '\n'; 
    return 0;
}