#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<iomanip>
using namespace std;

const int maxn = 21;

int NOD(int a, int b)
{
    if(a < b)
    {
        a = a+b;
        b = a-b;
        a = a-b;
    }
    int p;
    while (b != 0)
    {
        p = a;
        a = b;
        b = p%b;
    }
    return a;
}

struct drob
{
    int x;
    int y;
    void s()
    {
        int nod = NOD(x , y);
        x /= nod;
        y /= nod;
    }
};

int n, p[maxn];
double ans;
bool used[maxn];
drob a[maxn][maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n ;
    int i, j, z;
    for(i=1; i<=n; ++i)
    {
        for(j=1; j<=n; ++j)
        {
            cin >> z ;
            a[i][j] = {z,100};
            a[i][j].s();
        }
    }
}

void check()
{
    drob v = {1,1};
    int i;
    for(i=1; i<=n; ++i)
    {
        v.x *= a[p[i]][i].x;
        v.y *= a[p[i]][i].y;
        v.s();
    }

    drob z = {100 , v.y};
    z.s();
    double otg = (double)(v.x*z.x) / (double)(z.y);
    if(ans < otg) ans = otg;
}

void gen(int pos)
{
    if(pos > n)
    {
        check();
        return;
    }
    int i;
    for(i=1; i<=n; ++i)
    {
        if(!used[i])
        {
            used[i] = true;
            p[pos] = i;
            gen(pos+1);
            used[i] = false;
        }
    }
}

void solve()
{
    gen(1);
    std::cout << std::fixed;
    std::cout << std::setprecision(6);
    cout << ans << '\n' ;
}

int main()
{
    read();
    solve();
    return 0;
}
