#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const int maxn = 4e5 + 10;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

struct edge
{
    int ver, len;
    ll path;

    bool operator < (const edge &e) const
    {
        /**if (len < e.len)
            return false;
        if (len > e.len)
            return true;*/
        if (path < e.path)
            return false;
        return true;
    }
};

int n, m, used[maxn], to_get[maxn];
long long d[maxn];
vector < pair < int, long long > > g[maxn];

void read()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i ++)
    {
        int a, b;
        long long w;
        cin >> a >> b >> w;
        g[a].push_back({b, w});
        g[b].push_back({a, w});
    }
}

void djikstra(int s)
{
    for (int i = 1; i <= n; i ++)
        d[i] = 1e18, to_get[i] = n + 10;

    priority_queue < edge > pq;
    d[s] = 0;
    to_get[s] = 0;
    edge e;
    e.ver = s;
    e.len = 0;
    e.path = 0;
    pq.push(e);
    while(!pq.empty())
    {
        e = pq.top();
        pq.pop();
        if (!used[e.ver])
            if (e.path <= d[e.ver])// && e.len <= to_get[e.ver])
            {
                used[e.ver] = 1;
                for (pair < int, long long > to : g[e.ver])
                {
                    if (e.path + to.second < d[to.first])// && e.len + 1 <= to_get[to.first])
                    {
                        edge nb;
                        nb.ver = to.first;
                        nb.path = e.path + to.second;
                        nb.len = e.len + 1;
                        d[to.first] = nb.path;
                        to_get[to.first] = nb.len;
                        pq.push(nb);
                    }
                }
            }
    }
}
void solve()
{
    djikstra(1);
    cout << to_get[n] - 1 << " " << d[n] << endl;
    int q;
    cin >> q;
}
int main()
{
    speed();
    read();
    solve();
    return 0;
}
/**
5 5
1 2 1
2 4 9
1 3 2
3 4 3
4 5 5
0
*/
