#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const int maxn = 4e5 + 10;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

struct edge
{
    int ver, len;
    ll path;

    bool operator < (const edge &e) const
    {
        if (len < e.len)
            return false;
        if (len > e.len)
            return true;
        if (path < e.path)
            return false;
        return true;
    }
};

struct direct_edge
{
    int a, b;
    ll w;
    bool operator < (const direct_edge &e) const
    {
        return w < e.w;
    }
}de[maxn];

vector < pair < int, ll > > g[maxn];
int n, m, to_get[maxn], used[maxn];
ll d[maxn];

void read()
{
    cin >> n >> m;
    for (int i = 0; i < m; i ++)
        cin >> de[i].a >> de[i].b >> de[i].w;

    ///map < pair < int, int >, int > mp;
    sort(de, de + m);

    for (int i = 0; i < m; i ++)
    {
        int a = de[i].a, b= de[i].b;
        ll w = de[i].w;
        //if (mp[{a, b}] == 1 || mp[{b, a}] == 1)
          //  continue;
        //mp[{a, b}] = mp[{b, a}] = 1;
        g[a].push_back({b, w});
        g[b].push_back({a, w});
    }
}

void djikstra(int s)
{
    for (int i = 1; i <= n; i ++)
        d[i] = 1e18, to_get[i] = n + 10;

    priority_queue < edge > pq;
    d[s] = 0;
    to_get[s] = 0;
    edge e;
    e.ver = s;
    e.len = 0;
    e.path = 0;
    pq.push(e);
    while(!pq.empty())
    {
        e = pq.top();
        pq.pop();
        if (!used[e.ver])
            if (e.path <= d[e.ver] && e.len <= to_get[e.ver])
            {
                used[e.ver] = 1;
                for (pair < int, long long > to : g[e.ver])
                {
                    if (e.path + to.second < d[to.first] && e.len + 1 <= to_get[to.first])
                    {
                        edge nb;
                        nb.ver = to.first;
                        nb.path = e.path + to.second;
                        nb.len = e.len + 1;
                        d[to.first] = nb.path;
                        to_get[to.first] = nb.len;
                        pq.push(nb);
                    }
                }
            }
    }
}
void solve()
{
    djikstra(1);
    cout << to_get[n] - 1 << " " << d[n] << endl;
}

int main()
{
    read();
    solve();

    return 0;
}
