#include<bits/stdc++.h>
#define endl '\n'
const long long INF=1e10;
using namespace std;
struct node
{
    int v,tg;
    node() {}
    node(int a,int b)
    {
        v=a;
        tg=b;
    }
    bool operator< (const node& s) const
    {
        return tg>s.tg;
    }
};
int n,m,q;
int b,e,t;
vector<node>G[400005];
bool used[400005];
long long d[400005];
priority_queue<node>pq;
int par[400005];
bool cmp(node a,node b)
{
    if(a.v==b.v)return a.tg<b.tg;
    return a.v<b.v;
}
void dijkstra(int s)
{
    int p;
    d[s]=0;
    for(int i=2;i<=n;i++)d[i]=INF;
    par[s]=0;
    pq.push(node(s,0));
    while(!pq.empty())
    {
        s=pq.top().v;
        pq.pop();
        //if(used[s])continue;
        used[s]=1;
        p=G[s].size();
        for(int i=0;i<p;i++)
        {
            if(!used[G[s][i].v]&&d[s]+G[s][i].tg<d[G[s][i].v])
            {
                d[G[s][i].v]=d[s]+G[s][i].tg;
                pq.push(node(G[s][i].v,d[G[s][i].v]));
                par[G[s][i].v]=par[s]+1;
            }
        }
    }
}
int main()
{
ios::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);
cin>>n>>m;
for(int i=0;i<m;i++)
{
    cin>>b>>e>>t;
    G[b].push_back(node(e,t));
    G[e].push_back(node(b,t));
}
cin>>q;
for(int i=0;i<q;i++)
{
    cin>>b>>e;
}
for(int i=1;i<=n;i++)
{
    sort(G[i].begin(),G[i].end(),cmp);
    for(int j=0;j<G[i].size();j++)
    {
        if(used[G[i][j].v])
        {
            G[i].erase(G[i].begin()+j);
            j--;
        }
        else used[G[i][j].v]=1;
    }
    memset(used,0,sizeof(used));
}
dijkstra(1);
cout<<par[n]-1<<" "<<d[n]<<endl;
return 0;
}
