#include <bits/stdc++.h>
#define endl '\n'

int n, m, u, v, w, tests;
int x, y;
std::vector<std::pair<int, int> > conn[400001];
int dist[400001], dist1[400001];
int timeDist[400001], timeDist1[400001];
std::queue<int> q;

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);
    std::cout.tie(NULL);
    std::cin >> n >> m;
    for (int i = 0; i < m; ++ i) {
        std::cin >> u >> v >> w;
        conn[u].push_back({v, w});
        conn[v].push_back({u, w});
    }
    q.push(1);
    dist[1] = -1;
    timeDist[1] = 0;
    while (!q.empty()) {
        auto curr = q.front();
        q.pop();
        for (auto con : conn[curr]) {
            if (con.first != 1 && (timeDist[con.first] == 0 || dist[curr] + 1 <= dist[con.first])) {
                if (con.first != 1 && (timeDist[con.first] == 0 || dist[curr] + 1 < dist[con.first] || timeDist[curr] + con.second < timeDist[con.first])) {
                    timeDist[con.first] = timeDist[curr] + con.second;
                    q.push(con.first);
                }
                dist[con.first] = dist[curr] + 1;
            }
        }
    }
    q.push(n);
    dist1[n] = -1;
    timeDist1[n] = 0;
    while (!q.empty()) {
        auto curr = q.front();
        q.pop();
        for (auto con : conn[curr]) {
            if (con.first != 1 && (timeDist1[con.first] == 0 || dist1[curr] + 1 <= dist1[con.first])) {
                if (con.first != 1 && (timeDist1[con.first] == 0 || dist1[curr] + 1 < dist1[con.first] || timeDist1[curr] + con.second < timeDist1[con.first])) {
                    timeDist1[con.first] = timeDist1[curr] + con.second;
                    q.push(con.first);
                }
                dist1[con.first] = dist1[curr] + 1;
            }
        }
    }
    std::cout << dist[n] << ' ' << timeDist[n] << endl;
    std::cin >> tests;
    for (int t = 0; t < tests; ++ t) {
        std::cin >> x >> y;
        if (dist[x] + dist1[x] + 1 == dist[y] && timeDist[x] + timeDist1[x] == timeDist[y]) {
            std::cout << dist1[x] << ' ' << timeDist1[x] << endl;
        } else {
            std::cout << 0 << endl;
        }
    }
    return 0;
}
/*
5 6
1 2 1
2 3 2
1 3 5
3 4 1
3 5 3
4 5 1
*/
