#include <bits/stdc++.h>
#define endl '\n'

int n;
double probability[21][21];
double mem[21][(1 << 15) - 1];

double dp(int firm, int mask) {
    if (mask == (1 << n) - 1) { return 1; }
    if (mem[firm][mask] >= 0) { return mem[firm][mask]; }
    double ans;
    for (int i = 0; i < n; ++ i) {
        if (!((mask >> i) & 1)) {
            mask |= (1 << i);
            ans = std::max(ans, probability[firm][i] * dp(firm - 1, mask));
            mask ^= (1 << i);
        }
    }
    return mem[firm][mask] = ans;
}

int main() {
    std::cin >> n;
    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < (1 << n) - 1; ++ i) {
            std::cout << i << ' ' << j << endl;
            mem[i][j] = -1;
        }
    }
    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < n; ++ j) {
            std::cin >> probability[i][j];
            probability[i][j] /= 100;
        }
    }
    printf("%.6f", dp(n - 1, 0));
    return 0;
}
