#include <iostream>
#include <vector>
#include <climits>
using namespace std;
const int N_MAX = 400000;
vector<pair<int, int> > susedi[N_MAX];
int n, m;
int min_steps = N_MAX, min_dist = INT_MAX;
int x, y;

pair<int, int> dfs(int dist, int steps, int vruh, bool been[N_MAX], const int& finish){
    if (been[vruh] || dist > min_dist || min_steps < steps) {
        pair<int, int> tool;
        tool.first = N_MAX + 1;
        tool.second = N_MAX + 1;
        return tool;
    }
    been[vruh] = true;
    if (vruh == finish) {
        if (steps < min_steps) {
            min_steps == steps;
        } else if (dist < min_dist) {
            min_dist = dist;
        }
        been[vruh] = false;
        return {steps, dist};
    }
    int pot_min_steps = N_MAX, pot_min_dist = INT_MAX;
    for (int i = 0; i < susedi[vruh].size(); i++) {
        pair<int, int> curr = dfs(dist + susedi[vruh][i].second, steps + 1, susedi[vruh][i].first, been, finish);
        if (curr.second < pot_min_dist) {
            pot_min_steps = curr.first;
            pot_min_dist = curr.second;
        }
    }
    if (pot_min_dist < min_dist) {
        min_steps = pot_min_steps;
        min_dist = pot_min_dist;
        been[vruh] = false;
        return {min_steps, min_dist};
    }
    pair<int, int> tool;
    tool.first = N_MAX + 1;
    tool.second = N_MAX + 1;
    been[vruh] = false;
    return tool;
}


int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        pair<int, int> tool;
        tool.first = b;
        tool.second = c;
        susedi[a].push_back(tool);
        tool.first = a;
        susedi[b].push_back(tool);
    }
    bool been[N_MAX];
    for (int i = 0; i < N_MAX; i++) {
        been[i] = false;
    }
    pair<int, int> ans = dfs(0, 0, 0, been, n - 1);
    if (min_steps == 0) {
        cout << "0 " << min_dist << "\n";
    }
    cout << min_steps - 1 << " " << min_dist << "\n";

    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        cin >> x >> y;
        x--;
        y--;
        min_steps = N_MAX;
        min_dist = INT_MAX;
        if (x == 0) {
            pair<int, int> ans = dfs(0, 0, 0, been, y);
            cout << min_steps - 1 << " ";
            cout << min_dist << "\n";
            continue;
        } else if (y == 0) {
            cout << "0\n";
            continue;
        }
        pair<int, int> a, b, c;

        a = dfs(0, 0, 0, been, x);
        a.first = min_steps;
        a.second = min_dist;

        min_steps = N_MAX;
        min_dist = INT_MAX;
        b = dfs(0, 0, x, been, y);
        b.first = min_steps;
        b.second = min_dist;

        min_steps = N_MAX;
        min_dist = INT_MAX;
        c = dfs(0, 0, 0, been, y);
        c.first = min_steps;
        c.second = min_dist;

        if (a.first + b.first == c.first && a.second + b.second == c.second) {
            if (b.first == 0) {
                cout << "0 " << b.second << "\n";
            }
            cout << b.first - 1 << " " << b.second << "\n";
        } else {
            cout << "0\n";
        }
    }



    return 0;
}

