#include <iostream>
#include <vector>
#include <queue>
#include <climits>
using namespace std;
const int N_MAX = 400000;
struct moment {
    int node;
    int step;
    int dist;
};
vector<pair<int, int> > susedi[N_MAX];
bool been[N_MAX];
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    queue<moment> q;
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        susedi[a].push_back({b, c});
        susedi[b].push_back({a, c});
    }
    q.push({0, 0, 0});
    int min_steps = N_MAX, min_dist = INT_MAX;
    while (!q.empty()) {
        moment curr = q.front();
        q.pop();
        if (min_steps < curr.step) {
            break;
        }
        if (been[curr.node]) {
            continue;
        }
        if (curr.node == n - 1) {
            if (min_steps > curr.step) {
                min_steps = curr.step;
                min_dist = curr.dist;
            } else if (min_steps == curr.step && min_dist > curr.dist) {
                min_dist = curr.dist;
            }
            if (min_dist > curr.dist) {
                min_dist = curr.dist;
                min_steps = curr.step;
            }
            continue;
        }
        been[curr.node] = true;
        for (int i = 0; i < susedi[curr.node].size(); i++) {
            q.push({susedi[curr.node][i].first, curr.step + 1, curr.dist + susedi[curr.node][i].second});
        }
    }
    cout << min_steps - 1 << " " << min_dist;
    int quest;
    cin >> quest;
    return 0;
}
