#include<iostream>
#include<unordered_set>
#include<algorithm>
#include<assert.h>
#include<vector>
using namespace std;
const int mod=1e8+7;
vector <long long int> find_divs (long long int num) {
    vector <long long int> divs;
    for (long long int i=1; i*i<=num; i++) {
        if (num%i==0) {
            divs.push_back(i);
            if (num/i!=i) divs.push_back(num/i);
        }
    }
    sort(divs.begin(),divs.end());
    return divs;
}
int check (long long int div, int q_rem, long long int b) {
    long long int a=div+b;
    long long int k=q_rem+2*b;
    if ((1-a-b+k)%2==0) return 1;
    return 0;
}
int main () {
    int t;
    cin >> t ;
    assert((t>=1)&&(t<=10));
    for (int test=1; test<=t; test++) {
        long long int b;
        cin >> b ;
        assert((b>=1)&&(b<1e8));
        vector <long long int> div2b=find_divs(2*b);
        vector <long long int> divb=find_divs(b);
        long long int ans=0;
        unordered_set <long long int> divs;
        for (auto div1 : div2b) {
            for (auto div2 : divb) {
                long long int div=div1*div2;
                //cout << div << " " << div/(b/div2) << " " << (2*b/div1) << "  ";
                if (div/(b/div2)>=(2*b/div1)) break;
                if (divs.count(div)==1) continue;
                divs.insert(div);
                ans+=check(div,((2*b/div1)%2)*((b/div2)%2),b); ans%=mod;
            }
        }
        cout << ans << endl ;
    }
    return 0;
}
/*
a*(c+c+a-1)=b*(c+a+c+a+b-1)
2a*c+a*(a-1)=2b*c+b*(2a+b-1)
c=2ab+b*b-b-a*a+a/(2*(a-b))=
(a-b)*(1-a-b)+2*a*b/(2*(a-b))=
=(a-b)*(1-a-b)+k*(a-b)/(2*(a-b))=
=(1-a-b+k)/2

=> k>a+b

(a-b)|2ab

k(a-b)=2ab
ka-kb=2ab
ka-2ab-kb+2b*b=2b*b
a(k-2b)-b(k-2b)=2b*b
(a-b)(k-2b)=2b*b

k>a+b => (k-2b)>a-b => 2b*b>(a-b)^2 => (a-b)<sqrt(2*b*b)
*/
