#include<iostream>
#include<vector>
#include<queue>
#include<cstdio>
using namespace std;
const int MAX_N=400005;
const int MAX_P=1000000000;
//q=0
int n,m;
vector<pair<int,int> >v[MAX_N];
int level[MAX_N];
int dist[MAX_N];
int q;
void Read()
{
    scanf("%d %d",&n,&m);
    int x,y,t;
    for(int i=1;i<=m;i++)
    {
        scanf("%d %d %d",&x,&y,&t);
        v[x].push_back(make_pair(y,t));
        v[y].push_back(make_pair(x,t));
    }
    scanf("%d",&q);
    for(int i=2;i<=n;i++)
    {
        dist[i]=MAX_P;
    }
}
void BFS()
{
    queue<int>q;
    level[1]=0;
    q.push(1);
    dist[1]=0;
    while(!q.empty())
    {
        int k=q.front();
        q.pop();
        for(int i=0;i<v[k].size();i++)
        {
            int vert=v[k][i].first;
            int price=v[k][i].second;
            if(vert==1)continue;
            if(level[vert]==0)
            {
                level[vert]=level[k]+1;
                dist[vert]=dist[k]+price;
                q.push(vert);
            }
            else
            {
                if(level[k]+1==level[vert])
                {
                    dist[vert]=min(dist[vert],dist[k]+price);
                }
            }
        }
    }
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    Read();
    BFS();
    cout<<level[n]-1<<" "<<dist[n]<<endl;








    return 0;
}
/*
5 8
1 2 1
2 3 2
1 3 5
3 4 1
3 5 3
4 5 1
1 6 2
6 5 2


3
2 3
3 5
1 4

*/
