#include<iostream>
#include<vector>
#include<queue>
#include<cstdio>
using namespace std;
const int MAX_N=400005;
const int MAX_P=1000000000;

int n,m;
vector<pair<int,int> >v[MAX_N];
int level[MAX_N];
int dist[MAX_N];
int q;

int parent[MAX_N];
void Read()
{
    scanf("%d %d",&n,&m);
    int x,y,t;
    for(int i=1;i<=m;i++)
    {
        scanf("%d %d %d",&x,&y,&t);
        v[x].push_back(make_pair(y,t));
        v[y].push_back(make_pair(x,t));
    }
    for(int i=2;i<=n;i++)
    {
        dist[i]=MAX_P;
    }
}
void BFS()
{
    queue<int>q;
    level[1]=0;
    q.push(1);
    dist[1]=0;
    while(!q.empty())
    {
        int k=q.front();
        q.pop();
        for(int i=0;i<v[k].size();i++)
        {
            int vert=v[k][i].first;
            int price=v[k][i].second;
            if(vert==1)continue;
            if(level[vert]==0)
            {
                level[vert]=level[k]+1;
                dist[vert]=dist[k]+price;
                q.push(vert);
                parent[vert]=k;
            }
            else
            {
                if(level[k]+1==level[vert])
                {
                    if(dist[vert]>dist[k]+price)
                    {
                        dist[vert]=dist[k]+price;
                        parent[vert]=k;
                    }
                }
            }
        }
    }
}
int f;
int cur;
int Path(int e,int me)
{
    if(f==0)
    {
    for(int i=0;i<v[e].size();i++)
    {
        if(v[e][i].first==parent[e]){cur+=v[e][i].second;break;}
    }
    }
    if(parent[e]==me)
    {
        f=1;
        return 0;
    }
    if(parent[e]==1)return 0;

    int ans=0;
    ans=ans+Path(parent[e],me)+1;
    return ans;
}
void Queries()
{
    scanf("%d",&q);
    int x,y;
    int ans=0;
    for(int i=1;i<=q;i++)
    {
        scanf("%d %d",&x,&y);
        f=0;
        cur=0;
        ans=Path(y,x);
        if(f==0)printf("%d\n",f);
        else
        {
            printf("%d %d\n",ans,cur);
            //out<<ans<<" "<<cur<<endl;
        }
    }
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    Read();
    BFS();
    cout<<level[n]-1<<" "<<dist[n]<<endl;
    Queries();








    return 0;
}
/*
5 8
1 2 1
2 3 2
1 3 5
3 4 1
3 5 3
4 5 1
1 6 2
6 5 2


3
2 3
3 5
1 4


/////////
5 6
1 2 1
2 3 2
1 3 5
3 4 1
3 5 3
4 5 1
3
2 3
3 5
1 4

*/
