#include <iostream>
#include <iomanip>
#include <algorithm>
using namespace std;
const int maxn = 21;

double a[maxn][maxn];
int n, x;
int perm[] = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};

double f() {
    double ret = 0.0, curr;
    do {
        curr = 1.0;
        for (int i = 0 ; i < n ; ++i)
            curr *= a[i][perm[i]];
        ret = max(ret, curr);
    } while (next_permutation(perm, perm+n));
    return ret;
}

int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    for (int i = 0 ; i < n ; ++i) {
        for (int j = 0 ; j < n ; ++j) {
            cin >> x;
            a[i][j] = (double)x / 100.0000000;
        }
    }
    cout << fixed << setprecision(7) << 100.0000000*f() << '\n'; 
    return 0;
}