#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

struct edge
{
    int v, len;
    edge() {}
    edge(int a, int b)
    {
        v=a;
        len=b;
    }
};

int n, m;
vector<edge> gr[400005];
int par[20][400005], dist[400005];
int la[400005];
bool fi[4000005];

stack<int> zaizp;
queue<int> qu;

void bfs()
{
    par[0][1]=-1;
    dist[1]=0;
    fi[1]=1;
    qu.push(1);
    while(!qu.empty() || !zaizp.empty())
    {
        if(qu.empty())
        {
            while(!zaizp.empty())
            {
                fi[zaizp.top()]=1;
                qu.push(zaizp.top());
                la[zaizp.top()]=la[par[0][zaizp.top()]]+1;
                zaizp.pop();
            }
        }
        int tv=qu.front();
        qu.pop();
        int brs=gr[tv].size();
        for(int i=0; i<brs; i++)
        {
            int nv=gr[tv][i].v, nlen=gr[tv][i].len+dist[tv];
            if(fi[nv]) continue;
            if(!par[0][nv])
            {
                par[0][nv]=tv;
                dist[nv]=nlen;
                zaizp.push(nv);
            }
            else if(nlen<dist[nv])
            {
                par[0][nv]=tv;
                dist[nv]=nlen;
            }
        }
    }
///    for(int i=1; i<=n; i++) cout<<par[0][i]<<" "<<la[i]<<" "<<dist[i]<<endl;
}

void buildsp()
{
    for(int i=1; i<20; i++)
    {
        for(int j=1; j<=n; j++)
        {
            int vr=par[i-1][j];
            if(vr==-1) par[i][j]=-1;
            else par[i][j]=par[i-1][vr];
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    for(int i=0; i<m; i++)
    {
        int v1, v2, t;
        cin>>v1>>v2>>t;
        gr[v1].push_back(edge(v2, t));
        gr[v2].push_back(edge(v1, t));
    }
    bfs();
    buildsp();
    cout<<la[n]-1<<" "<<dist[n]<<endl;
    int q;
    cin>>q;
    for(int i=0; i<q; i++)
    {
        int vr1, vr2, oldvr2;
        cin>>vr1>>vr2;
        oldvr2=vr2;
        int difl=la[vr2]-la[vr1];
        if(difl<0)
        {
            cout<<0<<endl;
        }
        else
        {
            int id=19;
            while(difl)
            {
                if((1<<id)<=difl)
                {
                    vr2=par[id][vr2];
                    difl-=(1<<id);
                }
                id--;
            }
            if(vr2!=vr1) cout<<0<<endl;
            else
            {
                cout<<la[oldvr2]-la[vr1]-1<<" "<<dist[oldvr2]-dist[vr1]<<endl;
            }
        }
    }
    return 0;
}
/**
5 6
1 2 1
2 3 2
1 3 5
3 4 1
3 5 3
4 5 1
3
2 3
3 5
1 4
*/
