#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

struct node
{
    int v, t;
    node () {};
    node (int _v, int _t)
    {
        v = _v;
        t = _t;
    }
};

bool operator < (node a, node b)
{
    return a.t > b.t;
}
/// //////////////////////
int n, m;
int d[20001];
int d1[20001];
int br[20000];
bool used[20001];
vector <node> G[20001];
priority_queue<node> pq;
queue <int> q;


void bfs(int s)
{
    for (int i = 0; i <= n; i++)
    {
        d[i] = 2e9;
    }
    d[1] = 0;
    q.push(s);
    while (!q.empty())
    {
        int v = q.front();
        q.pop();
        if (used[v]) continue;
        used[v] = 1;

        int sz = G[v].size();
        for (int i = 0; i < sz; i++)
        {
            if (!used[G[v][i].v])
            {
                if (d1[v] + 1 < d1[G[v][i].v])
                {
                    d1[G[v][i].v] = d1[v] + 1;
                    d[G[v][i].v] = d[v] + G[v][i].t;
                }
                if (d1[v] + 1 == d1[G[v][i].v])
                {
                    d[G[v][i].v] = max(d[G[v][i].v], d[v] + G[v][i].t);
                }
                q.push(G[v][i].v);
            }
        }
    }
}

//void dfs(int s)
//{
//    if (used[s]) return;
//    used[s] = 1;
//    //cerr << s << endl;
//    int sz = G[s].size();
//    for (int i = 0; i < sz; i++)
//    {
//        d1[G[s][i].v] = min(d1[G[s][i].v], d1[s] + 1);
//        dfs(G[s][i].v);
//    }
//}

void go(int s)
{
    memset(used, 0, sizeof(used));
    memset(br, 0, sizeof(br));
    for (int i = 0; i <= n; i++)
    {
        d[i] = 2e9;
    }

    d[1] = 0;
    br[1] = 0;

    pq.push(node(1, 0));

    while (!pq.empty())
    {
        int v = pq.top().v;
        int tg = pq.top().t;
        pq.pop();

        if (used[v]) continue;
        used[v] = 1;

        int sz = G[v].size();
        for (int i = 0; i < sz; i++)
        {
            if (!used[G[v][i].v])
            {
                if (d[v] + G[v][i].t < d[G[v][i].v])
                {
                    d[G[v][i].v] = d[v] + G[v][i].t;
                    br[G[v][i].v] = br[v]+1;
                }
                pq.push(G[v][i]);
            }
        }
    }
    for (int i = 1; i <= n; i++)
    {
        cerr << br[i] << " ";
    }cerr << endl;
    for (int i = 1; i <= n; i++)
    {
        cerr << d[i] << " ";
    }cerr << endl;
}

int main ()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m;

    for (int i = 0; i < m; i++)
    {
        int x, y, t;
        cin >> x >> y >> t;
        G[x].push_back(node(y, t));
        G[y].push_back(node(x, t));
    }

    for (int i = 0; i <= n; i++)
    {
        d1[i] = 2e9;
    }
    d1[1] = 0;
    bfs(1);
    go(1);
    cout << d1[n]-1 << " " << d[n] << endl;

    int q;
    cin >> q;
    for (int i = 1; i <= q; i++)
    {
        int x, y;
        cin >> x >> y;
    }

    return 0;
}
/**
5 6
1 2 1
2 3 2
1 3 5
3 4 1
3 5 3
4 5 1
3
2 3
3 5
1 4

*/
