#include <bits/stdc++.h>
#define endl '\n'

int n, m, u, v, w, tests;
int x, y;
std::vector<std::pair<int, int> > conn[400001];
std::vector<int> passed[400001];
int dist[400001];
int timeDist[400001];
std::queue<int> q;

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);
    std::cout.tie(NULL);
    std::cin >> n >> m;
    for (int i = 0; i < m; ++ i) {
        std::cin >> u >> v >> w;
        conn[u].push_back({v, w});
        conn[v].push_back({u, w});
    }
    q.push(1);
    dist[1] = -1;
    timeDist[1] = 0;
    while (!q.empty()) {
        auto curr = q.front();
        q.pop();
        for (auto con : conn[curr]) {
            if (con.first != 1 && (timeDist[con.first] == 0 || dist[curr] + 1 <= dist[con.first])) {
                if (con.first != 1 && (timeDist[con.first] == 0 || dist[curr] + 1 < dist[con.first] || timeDist[curr] + con.second < timeDist[con.first])) {
                    passed[con.first].clear();
                    for (auto node : passed[curr]) {
                        passed[con.first].push_back(node);
                    }
                    passed[con.first].push_back(curr);
                    timeDist[con.first] = timeDist[curr] + con.second;
                    q.push(con.first);
                }
                dist[con.first] = dist[curr] + 1;
            }
        }
    }
    std::cout << dist[n] << ' ' << timeDist[n] << endl;
    std::cin >> tests;
    for (int t = 0; t < tests; ++ t) {
        std::cin >> x >> y;
        bool here = false;
        for (auto node : passed[y]) {
            if (node == x) {
                here = true;
                break;
            }
        }
        if (here) {
            std::cout << dist[y] - dist[x] - 1 << ' ' << timeDist[y] - timeDist[x] << endl;
        } else {
            std::cout << 0 << endl;
        }
    }
    return 0;
}
/*
5 6
1 2 1
2 3 2
1 3 5
3 4 1
3 5 3
4 5 1
*/
